diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
index af2bcd3d6..a7889c1d1 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsPumpkin.java
@@ -8,21 +8,22 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelCropsPumpkin<T extends BlockLogic> extends BlockModelStandard<T> {
     public static final IconCoordinate[] GROWTH_STAGE_TEXTURES_TOP = {
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage1_top"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage2_top"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage3_top"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage4_top")
+        TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage1_top"),
+        TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage2_top"),
+        TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage3_top"),
+        TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage4_top")
     };
     public static final IconCoordinate[] GROWTH_STAGE_TEXTURES_SIDE = {
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage1_side"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage2_side"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage3_side"),
-            TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage4_side")
+        TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage1_side"),
+        TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage2_side"),
+        TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage3_side"),
+        TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage4_side")
     };
 
     public static final IconCoordinate LEAF_TEXTURE = TextureRegistry.getTexture("minecraft:block/crops_pumpkin/stage0");
@@ -32,19 +33,18 @@ public class BlockModelCropsPumpkin<T extends BlockLogic> extends BlockModelStan
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
-        }else {
-        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
+        } else {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
-        final int meta = worldSource.getBlockMetadata(x, y, z);
+        final int meta = worldSource.getBlockData(tilePos);
         IconCoordinate leafTexture = LEAF_TEXTURE;
-        if(renderBlocks.overrideBlockTexture != null)
-        {
+        if (renderBlocks.overrideBlockTexture != null) {
             leafTexture = renderBlocks.overrideBlockTexture;
         }
         double uMin = leafTexture.getIconUMin();
@@ -52,12 +52,12 @@ public class BlockModelCropsPumpkin<T extends BlockLogic> extends BlockModelStan
         double vMin = leafTexture.getIconVMin();
         double vMax = leafTexture.getIconVMax();
 
-        double xMin = (x + 0.5D) - 0.25D;
-        double xMax = x + 0.5D + 0.25D;
-        double yMin = y + 0.0D;
-        double yMax = y + (3.0D / 16.0D);
-        double zMin = (z + 0.5D) - 0.5D;
-        double zMax = z + 0.5D + 0.5D;
+        double xMin = tilePos.x() + 0.5D - 0.25D;
+        double xMax = tilePos.x() + 0.5D + 0.25D;
+        double yMin = tilePos.y() + 0.0D;
+        double yMax = tilePos.y() + (3.0D / 16.0D);
+        double zMin = tilePos.z() + 0.5D - 0.5D;
+        double zMax = tilePos.z() + 0.5D + 0.5D;
         double extra = (10d / 16d);
         tessellator.addVertexWithUV(xMin - extra, yMax, zMax, uMin, vMin);
         tessellator.addVertexWithUV(xMax, yMin, zMax, uMin, vMax);
@@ -78,16 +78,18 @@ public class BlockModelCropsPumpkin<T extends BlockLogic> extends BlockModelStan
         tessellator.addVertexWithUV(xMin, yMin, zMax, uMin, vMax);
         tessellator.addVertexWithUV(xMin, yMin, zMin, uMax, vMax);
         tessellator.addVertexWithUV(xMax + extra, yMax, zMin, uMax, vMin);
-        if (meta >= 1) renderBlocks.renderStandardBlock(tessellator, worldSource, this, block.getBlockBoundsFromState(worldSource, x, y, z), x, y, z);
+        if (meta >= 1)
+            renderBlocks.renderStandardBlock(tessellator, worldSource, this, this.block.getBoundsFromState(worldSource, tilePos), tilePos);
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data) {
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
         if (data < 1 || data > 4) {
             data = 1;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
index 0f6b485c7..f55d93447 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCropsWheat.java
@@ -10,51 +10,51 @@ import net.minecraft.core.block.BlockLogicCropsWheat;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
 public class BlockModelCropsWheat<T extends BlockLogic> extends BlockModelStandard<T> {
     public final IconCoordinate[] growthStageTextures = {
-            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage0"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage1"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage2"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage3"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage4"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage5"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage6"),
-            TextureRegistry.getTexture("minecraft:block/crops_wheat/stage7")
+        TextureRegistry.getTexture("minecraft:block/crops_wheat/stage0"),
+        TextureRegistry.getTexture("minecraft:block/crops_wheat/stage1"),
+        TextureRegistry.getTexture("minecraft:block/crops_wheat/stage2"),
+        TextureRegistry.getTexture("minecraft:block/crops_wheat/stage3"),
+        TextureRegistry.getTexture("minecraft:block/crops_wheat/stage4"),
+        TextureRegistry.getTexture("minecraft:block/crops_wheat/stage5"),
+        TextureRegistry.getTexture("minecraft:block/crops_wheat/stage6"),
+        TextureRegistry.getTexture("minecraft:block/crops_wheat/stage7")
     };
 
     public BlockModelCropsWheat(Block<T> block) {
         super(block);
-        assert growthStageTextures.length == BlockLogicCropsWheat.MAX_GROWTH_STATE + 1 : "There must be a texture for each wheat growth stage!";
+        assert this.growthStageTextures.length == BlockLogicCropsWheat.MAX_GROWTH_STATE + 1 : "There must be a texture for each wheat growth stage!";
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
-        }else {
-        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
+        if (LightmapHelper.isLightmapEnabled()) {
+            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
+        } else {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
         }
         tessellator.setColorOpaque_F(brightness, brightness, brightness);
 
-        IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, worldSource.getBlockMetadata(x, y, z));
-        if(renderBlocks.overrideBlockTexture != null)
-        {
+        IconCoordinate texture = getBlockTextureFromSideAndMetadata(Side.BOTTOM, worldSource.getBlockData(tilePos));
+        if (renderBlocks.overrideBlockTexture != null) {
             texture = renderBlocks.overrideBlockTexture;
         }
         double uMin = texture.getIconUMin();
         double uMax = texture.getIconUMax();
         double vMin = texture.getIconVMin();
         double vMax = texture.getIconVMax();
-        double xMin = ((double) x + 0.5D) - 0.25D;
-        double xMax = (double) x + 0.5D + 0.25D;
-        double zMin = ((double) z + 0.5D) - 0.5D;
-        double zMax = (double) z + 0.5D + 0.5D;
+        double xMin = tilePos.x() + 0.5D - 0.25D;
+        double xMax = tilePos.x() + 0.5D + 0.25D;
+        double zMin = tilePos.z() + 0.5D - 0.5D;
+        double zMax = tilePos.z() + 0.5D + 0.5D;
 
-        double yd = (float)y - 0.0625F;
+        double yd = (float) tilePos.y() - 0.0625F;
         tessellator.addVertexWithUV(xMin, yd + 1.0D, zMin, uMin, vMin);
         tessellator.addVertexWithUV(xMin, yd + 0.0D, zMin, uMin, vMax);
         tessellator.addVertexWithUV(xMin, yd + 0.0D, zMax, uMax, vMax);
@@ -72,10 +72,10 @@ public class BlockModelCropsWheat<T extends BlockLogic> extends BlockModelStanda
         tessellator.addVertexWithUV(xMax, yd + 0.0D, zMax, uMax, vMax);
         tessellator.addVertexWithUV(xMax, yd + 1.0D, zMax, uMax, vMin);
 
-        xMin = ((double) x + 0.5D) - 0.5D;
-        xMax = (double) x + 0.5D + 0.5D;
-        zMin = ((double) z + 0.5D) - 0.25D;
-        zMax = (double) z + 0.5D + 0.25D;
+        xMin = tilePos.x() + 0.5D - 0.5D;
+        xMax = tilePos.x() + 0.5D + 0.5D;
+        zMin = tilePos.z() + 0.5D - 0.25D;
+        zMax = tilePos.z() + 0.5D + 0.25D;
         tessellator.addVertexWithUV(xMin, yd + 1.0D, zMin, uMin, vMin);
         tessellator.addVertexWithUV(xMin, yd + 0.0D, zMin, uMin, vMax);
         tessellator.addVertexWithUV(xMax, yd + 0.0D, zMin, uMax, vMax);
@@ -94,14 +94,14 @@ public class BlockModelCropsWheat<T extends BlockLogic> extends BlockModelStanda
         tessellator.addVertexWithUV(xMax, yd + 1.0D, zMax, uMax, vMin);
         return true;
     }
+
     @Override
     public boolean shouldItemRender3d() {
         return false;
     }
 
     @Override
-    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(Side side, int data)
-    {
-        return growthStageTextures[MathHelper.clamp(data, 0, BlockLogicCropsWheat.MAX_GROWTH_STATE)];
+    public @Nullable IconCoordinate getBlockTextureFromSideAndMetadata(@NotNull Side side, int data) {
+        return this.growthStageTextures[MathHelper.clamp(data, 0, BlockLogicCropsWheat.MAX_GROWTH_STATE)];
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
index c0a0ff117..25f506ac0 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrossedSquares.java
@@ -9,39 +9,38 @@ import net.minecraft.core.block.BlockLogic;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.opengl.GL11;
-import org.useless.dragonfly.DisplayPos;
 
 public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelStandard<T> {
     public BlockModelCrossedSquares(Block<T> block) {
         super(block);
     }
+
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
-        if (LightmapHelper.isLightmapEnabled()){
+        if (LightmapHelper.isLightmapEnabled()) {
             brightness = 1f;
         }
         float r = 1f;
         float g = 1f;
         float b = 1f;
         // Used for the rendering for the block inside the jar
-        GL11.glColor4f(1f, 1f, 1f,1f);
-        if(renderBlocks.useInventoryTint)
-        {
-            int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
-            r = (float)(color >> 16 & 0xff) / 255F;
-            g = (float)(color >> 8 & 0xff) / 255F;
-            b = (float)(color & 0xff) / 255F;
+        GL11.glColor4f(1f, 1f, 1f, 1f);
+        if (renderBlocks.useInventoryTint) {
+            int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
+            r = (float) (color >> 16 & 0xff) / 255F;
+            g = (float) (color >> 8 & 0xff) / 255F;
+            b = (float) (color & 0xff) / 255F;
         }
         final float yOffset = 0.0F;
 
         GL11.glTranslatef(-0.5F, -0.5f, -0.5F);
 
         IconCoordinate texIndex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata);
-        if(renderBlocks.overrideBlockTexture != null)
-        {
+        if (renderBlocks.overrideBlockTexture != null) {
             texIndex = renderBlocks.overrideBlockTexture;
         }
         final double minU = texIndex.getIconUMin();
@@ -51,7 +50,7 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
 
         tessellator.startDrawingQuads();
         tessellator.setColorRGBA_F(r * brightness, g * brightness, b * brightness, alpha);
-        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null){
+        if (LightmapHelper.isLightmapEnabled() && lightmapCoordinate != null) {
             tessellator.setLightmapCoord(lightmapCoordinate);
         }
 
@@ -87,38 +86,36 @@ public class BlockModelCrossedSquares<T extends BlockLogic> extends BlockModelSt
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
         float brightness = 1.0f;
-        if(!LightmapHelper.isLightmapEnabled()) {
-        	brightness = renderBlocks.getBlockBrightness(worldSource, x, y, z);
-        }else {
-        	tessellator.setLightmapCoord(block.getLightmapCoord(worldSource, x, y, z));
+        if (!LightmapHelper.isLightmapEnabled()) {
+            brightness = renderBlocks.getBlockBrightness(worldSource, tilePos);
+        } else {
+            tessellator.setLightmapCoord(this.block.getLightmapCoord(worldSource, tilePos));
         }
-        
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getWorldColor(worldSource, x, y, z, 0);
-        float r = (float)(color >> 16 & 0xff) / 255F;
-        float g = (float)(color >> 8 & 0xff) / 255F;
-        float b = (float)(color & 0xff) / 255F;
+
+        int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getWorldColor(worldSource, tilePos, 0);
+        float r = (float) (color >> 16 & 0xff) / 255F;
+        float g = (float) (color >> 8 & 0xff) / 255F;
+        float b = (float) (color & 0xff) / 255F;
         tessellator.setColorOpaque_F(brightness * r, brightness * g, brightness * b);
 
-        double xd = x;
-        double yd = y;
-        double zd = z;
+        double xd = tilePos.x();
+        double yd = tilePos.y();
+        double zd = tilePos.z();
 
         // Shift grass position with deterministic position based random
-        if(block == Blocks.TALLGRASS || block == Blocks.TALLGRASS_FERN || block == Blocks.SPINIFEX)
-        {
-            long dRandom = (x * 0x2fc20fL) ^ (long)z * 0x6ebfff5L ^ (long)y;
+        if (this.block == Blocks.TALLGRASS || this.block == Blocks.TALLGRASS_FERN || this.block == Blocks.SPINIFEX) {
+            long dRandom = (tilePos.x() * 0x2fc20fL) ^ (long) tilePos.z() * 0x6ebfff5L ^ (long) tilePos.y();
             dRandom = dRandom * dRandom * 0x285b825L + dRandom * 11L;
-            xd += ((double)((float)(dRandom >> 16 & 15L) / 15F) - 0.5D) * 0.5D;
-            yd += ((double)((float)(dRandom >> 20 & 15L) / 15F) - 1.0D) * 0.2D;
-            zd += ((double)((float)(dRandom >> 24 & 15L) / 15F) - 0.5D) * 0.5D;
+            xd += ((double) ((float) (dRandom >> 16 & 15L) / 15F) - 0.5D) * 0.5D;
+            yd += ((double) ((float) (dRandom >> 20 & 15L) / 15F) - 1.0D) * 0.2D;
+            zd += ((double) ((float) (dRandom >> 24 & 15L) / 15F) - 0.5D) * 0.5D;
         }
 
-        int metadata = worldSource.getBlockMetadata(x, y, z);
+        int metadata = worldSource.getBlockData(tilePos);
         IconCoordinate texIndex = getBlockTextureFromSideAndMetadata(Side.BOTTOM, metadata);
-        if(renderBlocks.overrideBlockTexture != null)
-        {
+        if (renderBlocks.overrideBlockTexture != null) {
             texIndex = renderBlocks.overrideBlockTexture;
         }
         final double minU = texIndex.getIconUMin();
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java
index 866218565..f25fd0de9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelCrystallineNetherrack.java
@@ -6,28 +6,31 @@ import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.BlockLogic;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.WorldSource;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 import org.lwjgl.opengl.GL11;
 
 public class BlockModelCrystallineNetherrack<T extends BlockLogic> extends BlockModelStandard<T> {
     protected IconCoordinate overlay;
+
     public BlockModelCrystallineNetherrack(Block<T> block) {
         super(block);
-        overlay = TextureRegistry.getTexture("minecraft:block/nether_crystal/overlay");
+        this.overlay = TextureRegistry.getTexture("minecraft:block/nether_crystal/overlay");
     }
 
     @Override
-    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, int x, int y, int z) {
-        AABB bounds = block.getBlockBoundsFromState(worldSource, x, y, z);
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z, 1.0f, 1.0f, 1.0f);
-        renderBlocks.overrideBlockTexture = overlay;
-        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, x, y, z);
+    public boolean render(@NotNull Tessellator tessellator, @NotNull WorldSource worldSource, @NotNull TilePosc tilePos) {
+        AABBdc bounds = this.block.getBoundsFromState(worldSource, tilePos);
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos, 1.0f, 1.0f, 1.0f);
+        renderBlocks.overrideBlockTexture = this.overlay;
+        renderBlocks.renderStandardBlock(tessellator, worldSource, this, bounds, tilePos);
         renderBlocks.overrideBlockTexture = null;
         return true;
     }
+
     @Override
     public void renderStandalone(@NotNull Tessellator tessellator, int metadata, float brightness, float alpha, @Nullable Integer lightmapCoordinate) {
         renderBlocks.useInventoryTint = false;
@@ -35,14 +38,14 @@ public class BlockModelCrystallineNetherrack<T extends BlockLogic> extends Block
         renderBlocks.useInventoryTint = true;
         GL11.glTranslatef(-0.5F, -0.5F, -0.5F);
 
-        int color = BlockColorDispatcher.getInstance().getDispatch(block).getFallbackColor(metadata, 0);
-        float r = (float)(color >> 16 & 0xff) / 255F;
-        float g = (float)(color >> 8 & 0xff) / 255F;
-        float b = (float)(color & 0xff) / 255F;
+        int color = BlockColorDispatcher.getInstance().getDispatch(this.block).getFallbackColor(metadata, 0);
+        float r = (float) (color >> 16 & 0xff) / 255F;
+        float g = (float) (color >> 8 & 0xff) / 255F;
+        float b = (float) (color & 0xff) / 255F;
         GL11.glColor4f(r * brightness, g * brightness, b * brightness, alpha);
 
-        AABB bounds = block.getBounds();
-        IconCoordinate coord = overlay;
+        AABBdc bounds = this.block.getBounds();
+        IconCoordinate coord = this.overlay;
 
         tessellator.startDrawingQuads();
         tessellator.setNormal(0.0F, -1F, 0.0F);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index e6acd9aa6..442561d01 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -17,32 +17,32 @@ import static net.minecraft.client.render.block.model.BlockModelStandard.OVERBRI
 import static net.minecraft.client.render.block.model.BlockModelStandard.RETRO_BLOCK_TEXTURES;
 
 public final class BlockModelDispatcher
-    extends Dispatcher<Block<?>, BlockModel<?>>
-{
+    extends Dispatcher<Block<?>, BlockModel<?>> {
     private static final Side[] S_TB = {Side.TOP, Side.BOTTOM};
     private static final Side[] S_SIDES = {Side.NORTH, Side.EAST, Side.SOUTH, Side.WEST};
 
     private static BlockModelDispatcher instance = new BlockModelDispatcher();
-    public static BlockModelDispatcher getInstance()
-    {
+
+    public static BlockModelDispatcher getInstance() {
         return instance;
     }
+
     public static BlockModelEmpty<?> modelEmpty = new BlockModelEmpty<>(null);
-    public void addDispatch(final BlockModel<?> model)
-    {
+
+    public void addDispatch(final BlockModel<?> model) {
         addDispatch(model.block, model);
     }
+
     @Override
-    public void addDispatch(final Block<?> key, final BlockModel<?> value)
-    {
-        if (hasDispatch(key)){
+    public void addDispatch(final Block<?> key, final BlockModel<?> value) {
+        if (hasDispatch(key)) {
             throw new IllegalArgumentException("Block '" + key.toString() + "' already assigned a model!");
         }
         this.dispatches.put(key, value);
     }
+
     @Override
-    protected BlockModel<?> getDefault()
-    {
+    protected BlockModel<?> getDefault() {
         return modelEmpty;
     }
 
@@ -431,9 +431,9 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_GRANITE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/diamond/granite"));
         addDispatch(new BlockModelStandard<>(Blocks.ORE_DIAMOND_PERMAFROST).setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/diamond/permafrost"));
 
-        addDispatch(new BlockModelStandard<>(Blocks.CRYSTAL).setAllTextures(BLOCK_TEXTURES,"minecraft:block/nether_crystal/crystal"));
-        addDispatch(new BlockModelCrossedSquares<>(Blocks.CRYSTAL_STALK).setAllTextures(BLOCK_TEXTURES,"minecraft:block/nether_crystal/stalk"));
-        addDispatch(new BlockModelCrystallineNetherrack<>(Blocks.NETHERRACK_CRYSTALLINE).setAllTextures(BLOCK_TEXTURES,"minecraft:block/nether_crystal/crystal_netherrack"));
+        addDispatch(new BlockModelStandard<>(Blocks.CRYSTAL).setAllTextures(BLOCK_TEXTURES, "minecraft:block/nether_crystal/crystal"));
+        addDispatch(new BlockModelCrossedSquares<>(Blocks.CRYSTAL_STALK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/nether_crystal/stalk"));
+        addDispatch(new BlockModelCrystallineNetherrack<>(Blocks.NETHERRACK_CRYSTALLINE).setAllTextures(BLOCK_TEXTURES, "minecraft:block/nether_crystal/crystal_netherrack"));
 
         addDispatch(new BlockModelStandard<>(Blocks.ORE_NETHERCOAL_NETHERRACK)
             .setAllTextures(BLOCK_TEXTURES, "minecraft:block/ore/nethercoal/netherrack")
@@ -516,21 +516,21 @@ public final class BlockModelDispatcher
             TextureRegistry.getTexture("minecraft:block/piston/face"))
             .setPistonTextures("minecraft:block/piston/side", "minecraft:block/piston/top", "minecraft:block/piston/bottom")
             .setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston/face")
-            .withCustomItemBounds(0,0,0,1,1,1));
+            .withCustomItemBounds(0, 0, 0, 1, 1, 1));
         addDispatch(new BlockModelPiston<>(Blocks.PISTON_BASE_STICKY,
             TextureRegistry.getTexture("minecraft:block/piston_sticky/face"))
             .setPistonTextures("minecraft:block/piston_sticky/side", "minecraft:block/piston_sticky/top", "minecraft:block/piston_sticky/bottom")
             .setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston_sticky/face")
-            .withCustomItemBounds(0,0,0,1,1,1));
+            .withCustomItemBounds(0, 0, 0, 1, 1, 1));
         addDispatch(new BlockModelPiston<>(Blocks.PISTON_BASE_STEEL,
-            TextureRegistry.getTexture("minecraft:block/piston_steel/face"), 6/16d)
+            TextureRegistry.getTexture("minecraft:block/piston_steel/face"), 6 / 16d)
             .setPistonTextures("minecraft:block/piston_steel/side", "minecraft:block/piston_steel/top", "minecraft:block/piston_steel/bottom")
             .setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston_steel/face")
-            .withCustomItemBounds(0,0,0,1,1,1));
+            .withCustomItemBounds(0, 0, 0, 1, 1, 1));
 
         addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD, TextureRegistry.getTexture("minecraft:block/piston/head"), TextureRegistry.getTexture("minecraft:block/piston/shaft")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston/face"));
         addDispatch(new BlockModelEmpty<>(Blocks.PISTON_MOVING).setAllTextures(BLOCK_TEXTURES, (IconCoordinate) null));
-        addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD_STEEL, TextureRegistry.getTexture("minecraft:block/piston_steel/head"), TextureRegistry.getTexture("minecraft:block/piston_steel/shaft"), 6/16d, 8d/16d).setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston_steel/face"));
+        addDispatch(new BlockModelPistonHead(Blocks.PISTON_HEAD_STEEL, TextureRegistry.getTexture("minecraft:block/piston_steel/head"), TextureRegistry.getTexture("minecraft:block/piston_steel/shaft"), 6 / 16d, 8d / 16d).setAllTextures(BLOCK_TEXTURES, "minecraft:block/piston_steel/face"));
 
         addDispatch(new BlockModelStandard<>(Blocks.NOTEBLOCK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/noteblock"));
 
@@ -791,9 +791,9 @@ public final class BlockModelDispatcher
 
         addDispatch(new BlockModelPebbles<>(Blocks.OVERLAY_PEBBLES));
 
-        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_CHAINLINK,TextureRegistry.getTexture("minecraft:block/fence_chain/center"), null, TextureRegistry.getTexture("minecraft:block/fence_chain/top"), TextureRegistry.getTexture("minecraft:block/fence_chain/column")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fence_chain/center"));
-        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_PAPER_WALL,TextureRegistry.getTexture("minecraft:block/fence_paper/center"), null, null, TextureRegistry.getTexture("minecraft:block/fence_paper/column")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fence_paper/center"));
-        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_STEEL,TextureRegistry.getTexture("minecraft:block/fence_steel/center"), null, TextureRegistry.getTexture("minecraft:block/fence_steel/top"), TextureRegistry.getTexture("minecraft:block/fence_steel/column")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fence_steel/center"));
+        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_CHAINLINK, TextureRegistry.getTexture("minecraft:block/fence_chain/center"), null, TextureRegistry.getTexture("minecraft:block/fence_chain/top"), TextureRegistry.getTexture("minecraft:block/fence_chain/column")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fence_chain/center"));
+        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_PAPER_WALL, TextureRegistry.getTexture("minecraft:block/fence_paper/center"), null, null, TextureRegistry.getTexture("minecraft:block/fence_paper/column")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fence_paper/center"));
+        addDispatch(new BlockModelFenceThin<>(Blocks.FENCE_STEEL, TextureRegistry.getTexture("minecraft:block/fence_steel/center"), null, TextureRegistry.getTexture("minecraft:block/fence_steel/top"), TextureRegistry.getTexture("minecraft:block/fence_steel/column")).setAllTextures(BLOCK_TEXTURES, "minecraft:block/fence_steel/center"));
 
         addDispatch(new BlockModelBasket<>(Blocks.BASKET)
             .setTex(BLOCK_TEXTURES, "minecraft:block/basket/bottom", S_TB)
